//+------------------------------------------------------------------+
//|                                               histogramtrend.mq4 |
//|                      Copyright  2011, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net 
  //|
//+------------------------------------------------------------------+



//+------------------------------------------------------------------+
//|                                              Histogramtrend2.mq4 |
//|                      Copyright  2011, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+

// represnete un histogramme des croisements

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 Black
#property indicator_color2 Red
#property indicator_color3 Green
#property indicator_color4 Gray
//--- input parameters
extern int       period1=13;
extern int       period2=7;
//--- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer6[];
double ExtMapBuffer7[];


//

double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
    IndicatorBuffers(7);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
   
   SetIndexStyle(2,DRAW_LINE,1,1,Green);
   SetIndexBuffer(2,ExtMapBuffer6);
   
   SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(3,ExtMapBuffer7);
   
    SetIndexBuffer(4,ExtMapBuffer3);
     SetIndexBuffer(5,ExtMapBuffer4);
      SetIndexBuffer(6,ExtMapBuffer5);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   
   int    counted_bars=IndicatorCounted();
   int limit ;
   
//----
	 if(counted_bars>0) counted_bars--;
		limit = Bars-counted_bars;
			
				for(int i=0;i<limit;i++)
				{
				  ExtMapBuffer3[i] = iMA(NULL,0,period1,0,MODE_LWMA,PRICE_CLOSE,i);
				}
				
					for(i=0;i<limit;i++)
				{
					ExtMapBuffer4[i] = iMAOnArray(ExtMapBuffer3,0,period2,0,MODE_LWMA,i);
				}
				
				for(i=0;i<limit;i++)
				{
					ExtMapBuffer5[i] = iMAOnArray(ExtMapBuffer4,0,period2,0,MODE_LWMA,i);
				}
				
				for(i=0;i<limit;i++)
				{
				    // histogram 
					ExtMapBuffer1[i] = (ExtMapBuffer4[i] - ExtMapBuffer5[i]);
				   
				}
				
				
				for(i=0;i<limit;i++)
				{
				
				   // ligne 
				    ExtMapBuffer2[i] = iMAOnArray(ExtMapBuffer1,0,period2,0,MODE_LWMA,i);  // 0 ; 
				   
				
				}
				
					for(i=0;i<limit;i++)
				{
				    ExtMapBuffer6[i] = ExtMapBuffer5[i] - ExtMapBuffer4[i];
				
				}
				
				
					for(i=0;i<limit;i++)
				{
				    ExtMapBuffer7[i] = ExtMapBuffer1[i] - ExtMapBuffer2[i];
				
				}
   
//----
   return(0);
  }
//+------------------------------------------------------------------+